require("lib")
viewer = require("viewer")

--function obj_control:start()
--  local y = 2 -- local variable of this function
--  print("This function starts before first draw on screen ")
--end

--function obj_control:timer(dt)
--  local sinVal = math.sin(dt)
--  print("This function starts in each frame with time from last frame dt in ms", dt, " sin val = ", sinVal)
--end

obj_control = class()

 -- объявляем переменные
function obj_control:init()
  self.res  = 0
  self.valLeft  = 0
  self.valRight = 0
  self.valRightExiste = false
  self.operatorSelected = false
  self.operator = ""
  self.txt = ""
end

 -- вызываем функцию
function obj_control:state(state,guestID)
  
    -- читаем параметр машины, в котором записана цифра
   function pressedDigit()
      --print("self.operatorSelected = x self.valLeft = ",self.valLeft, "self.valRight = ",self.valRight)     
      local digit = viewer.getObjParamI(ID("control"),"pressed",0)
      if (self.operatorSelected) then
	      self.valRight = (self.valRight * 10) + digit
        self.valRightExiste = true
        
        -- добавляем введенные символы к строке
        self.txt = self.txt..self.valRight
        viewer.setObjParamS(ID("resultOperator"),"txt",self.txt)
        viewer.changeObjState(ID("resultOperator"),"init")  
        
        -- выводим значение первой переменной
        viewer.setObjParamI(ID("result"),"val",self.valRight)
        viewer.changeObjState(ID("result"),"init")
	else
	      self.valLeft = (self.valLeft * 10) + digit
        
        -- добавляем введенные символы к строке
        self.txt = self.txt..digit
        viewer.setObjParamS(ID("resultOperator"),"txt",self.txt)
        viewer.changeObjState(ID("resultOperator"),"init") 
        
        -- выводим значение второй переменной
        viewer.setObjParamI(ID("result"),"val",self.valLeft)
        viewer.changeObjState(ID("result"),"init")
        
      end
      --print("self.operatorSelected = x self.valLeft = ",self.valLeft, "self.valRight = ",self.valRight)
   end
   
    -- читаем параметр машины, в котором записан оператор
   function pressedOperator()
     	 
        self.operator = viewer.getObjParamS(ID("control"),"operator","")
        if (self.operatorSelected)==false then
          self.txt = self.txt..self.operator
          self.operatorSelected = true 
          
         
               
        elseif (self.valRightExiste) then
            pressedRavno()
            self.txt = self.txt..self.operator
            self.operatorSelected = true 
        
           else
            
          --обрезаем последний символ строки, если ранее был выбран оператор
          --возвратит строку без последнего символа
          self.txt = string.sub (self.txt,1,string.len(self.txt)-1)
          self.txt = self.txt..self.operator
          
        end
  
     
      -- записываем строку вычислений, если ввели оператор
      
      viewer.setObjParamS(ID("resultOperator"),"txt",self.txt)
      viewer.changeObjState(ID("resultOperator"),"init")
      
   end
   
          -- выполняем математические вычисления в зависимости от оператора
   function pressedRavno() 
      --print("self.operator = ",self.operator, " self.valLeft ",self.valLeft)     
      if (self.operator == "+") then 
        self.res = self.valLeft + self.valRight
      elseif (self.operator == "-") then 
        self.res = self.valLeft - self.valRight
      elseif (self.operator == "*") then 
        self.res = self.valLeft * self.valRight
      elseif (self.operator == "/") then 
        self.res = self.valLeft / self.valRight
      end
       
      self.valRightExiste = false
      
       -- выводим результат 
      viewer.setObjParamF(ID("result"),"val",self.res)
      viewer.changeObjState(ID("result"),"init")
      self.operatorSelected = false
      
      self.valLeft = self.res
      self.valRight = 0
            
   end
   
   -- обнуление вычислений
   function pressedCancel() 
      obj_control:init()
       
      viewer.setObjParamF(ID("result"),"val",0)
      viewer.changeObjState(ID("result"),"init")
      
      viewer.setObjParamS(ID("resultOperator"),"txt",0)
      viewer.changeObjState(ID("resultOperator"),"init")
     
   end
  
  if (state == "pressedDigit") then 
	pressedDigit() 
    	elseif(state == "pressedOperator") then 
	pressedOperator()
    	elseif(state == "pressedRavno") then 
	pressedRavno()
    	elseif(state == "pressedCancel") then 
	pressedCancel()
  end
end



